#include <iostream>

using namespace std;

int main()
{
    int n, k;
    cin >> n >> k;
    int d[k];
    for(int i = 0; i < k; i++){
        int x, s = 0;
        cin >> x;
        for(int j = 1; j <= x; j++){
            if(x % j == 0){
                s = s ^ j;
            }
        }
        d[i] = s;
    }
    for(int i = 0; i < k; i++){
        cout << d[i] << " ";
    }
    return 0;
}